POV-Ray : Newsgroups : povray.advanced-users : Something more theoretical.... Server Time
29 Jul 2024 16:29:23 EDT (-0400)
  Something more theoretical.... (Message 14 to 23 of 23)  
<<< Previous 10 Messages Goto Initial 10 Messages
From: Shay
Subject: Re: Something more theoretical....
Date: 17 Apr 2002 12:05:56
Message: <3cbd9d64@news.povray.org>
Jan Walzer <jan### [at] lzernet> wrote in message
news:3cbc5eab@news.povray.org...

I wouldn't consider myself an advanced user, but I do have a suggestion.

I would cover the viewing area in rows of boxes with a random x and z size
within a range. I would then randomly select the number of balls to be
placed in each box and place the balls as I go, checking for intersections
within this small box. I think that this would give the best pseudo-random
look in the least amount of time.

 -Shay


Post a reply to this message

From: Christopher James Huff
Subject: Re: Something more theoretical....
Date: 17 Apr 2002 16:54:39
Message: <chrishuff-4912F5.15565117042002@netplex.aussie.org>
In article <3cbd31c0$1@news.povray.org>, "Jan Walzer" <jan### [at] lzernet> 
wrote:

> in POV-SDL ? ...
> 
> I've thought about this, but I dunno how I could
> do this, if I haven't some kind of "references"

You can use unions to group objects, and you can put unions inside 
unions.

Assuming you have a line of 16 objects like this:

A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P

Split it into two groups, put each into a union and make a union of the 
unions. Split each sub-union the same way.
The resulting structure would be like:

union {
    union {
        union {
            union {A, B},
            union {C, D}
        },
        union {
            union {E, F},
            union {G, H}
        }
    },
    union {
        union {
            union {I, J},
            union {K, L}
        },
        union {
            union {M, N},
            union {O, P}
        }
    }
}

This basically makes POV do a binary search through the objects instead 
of brute-force testing all of them. I used a line for simplicity, but 
the technique could be used for 2D and 3D grids or other structures.

-- 
Christopher James Huff <chr### [at] maccom>
POV-Ray TAG e-mail: chr### [at] tagpovrayorg
TAG web site: http://tag.povray.org/


Post a reply to this message

From: Jan Walzer
Subject: Re: Something more theoretical....
Date: 17 Apr 2002 17:38:06
Message: <3cbdeb3e$1@news.povray.org>
Sorry, but I don't get, how this could
help me with my current problem. Maybe
because its a bit late already... Give
me the chance to sleep about this idea
,but I doubt that this union-structure
will help me very much with a good way
to test for intersections.

What I want to to is to compute all of
the positions in SDL before postioning
them. But to do this efficient I think
I need something like references to be
able to create list or tree structures
like they are common in other programm-
ing languages.

It could be able to create such things
with the help of some arrays and a lot
macros. But the overhead would be more
than neccesary and the efficiency gets
lost, so it would no longer be faster
than my current approach...


Post a reply to this message

From: JRG
Subject: Re: Something more theoretical....
Date: 17 Apr 2002 18:23:01
Message: <3cbdf5c5@news.povray.org>
"Jan Walzer" wrote:
>
> "JRG" <jrg### [at] hotmailcom> wrote:
> > Usually jittering is done in such way to make it impossible to have
intersections.
> > That would make it a O(0)... ;-)
>
> BTW: I just read your text again...
>
> O(0) is not possible for any real algorithm ...

I was referring to the intersection testing algorithm alone, not to the placing
algorithm as a whole... no test, no algorithm, no operations, nada de nada... hence
the O(0) which, anyway, was just a joke... :)

--
Jonathan.

Home: http://digilander.iol.it/jrgpov


Post a reply to this message

From: Slime
Subject: Re: Something more theoretical....
Date: 17 Apr 2002 20:45:07
Message: <3cbe1713$1@news.povray.org>
> So I wonder, if there are other, more advanced algorithms out there, which
are
> faster ...

Here's an idea I just came up with.

Do it just like you are. Except, as you place the spheres, keep the array
that holds their positions *sorted*. So, when you add a new value to the
array, use some sort of binary search to find the part of the array where
the new position should be kept. (To sort the array, do something like
sorting first in the X direction, and then in the Z direction.) Then insert
the new value there, pushing the rest of the values ahead.

Then, when you have a new position, you still have to check the array to
make sure it doesn't conflict with any of the positions already there.
However, you no longer have to check the whole array - you only have to
check the part of the array that's within twice the maximum possible radius
from the new position you're testing.

It might be difficult to implement, but it might really speed it up. The key
thing here is to search the array with a binary search or something else
that takes advantage of its sortedness.

- Slime
[ http://www.slimeland.com/ ]
[ http://www.slimeland.com/images/ ]


Post a reply to this message

From: Peter Popov
Subject: Re: Something more theoretical....
Date: 18 Apr 2002 01:32:39
Message: <acmsbug02mi0svchs83a39up804utm517s@4ax.com>
On Wed, 17 Apr 2002 10:26:41 +0200, "Jan Walzer" <jan### [at] lzernet>
wrote:

>in POV-SDL ? ...

Supposedly :)

>I've thought about this, but I dunno how I could
>do this, if I haven't some kind of "references"

You can make a binary tree with a one-dimensional array. The extension
to oct-trees should be straightforward.


Peter Popov ICQ : 15002700
Personal e-mail : pet### [at] vipbg
TAG      e-mail : pet### [at] tagpovrayorg


Post a reply to this message

From: Slime
Subject: Re: Something more theoretical....
Date: 21 Apr 2002 13:58:11
Message: <3cc2fdb3$1@news.povray.org>
I have come up with an algorithm that, although it is still O(n^2), can
place 16,000 spheres in, if I remember correctly, 13 minutes in the POV SDL.
It gets faster, of course, when the spheres are less densely placed. In this
example, about one out of every ten spheres needed more than one placement
to find a place that didn't intersect with other spheres.

I'm rendering now, I can post the source or the steps to the algorithm when
it's done, if you like. Might be a while... with focal blur and media, it's
going at 2 pps along the horizon line; so expect at least another day.

- Slime
[ http://www.slimeland.com/ ]
[ http://www.slimeland.com/images/ ]


Post a reply to this message

From: jimbobjim
Subject: Re: Something more theoretical....
Date: 21 Apr 2002 15:35:24
Message: <3cc3147c@news.povray.org>
"Slime" <noo### [at] hotmailcom> wrote in message
news:3cbe1713$1@news.povray.org...
> > So I wonder, if there are other, more advanced algorithms out there,
which
> are
> > faster ...
>
> Here's an idea I just came up with.
>
> Do it just like you are. Except, as you place the spheres, keep the array
> that holds their positions *sorted*. So, when you add a new value to the
> array, use some sort of binary search to find the part of the array where
> the new position should be kept. (To sort the array, do something like
> sorting first in the X direction, and then in the Z direction.) Then
insert
> the new value there, pushing the rest of the values ahead.
>
> Then, when you have a new position, you still have to check the array to
> make sure it doesn't conflict with any of the positions already there.
> However, you no longer have to check the whole array - you only have to
> check the part of the array that's within twice the maximum possible
radius
> from the new position you're testing.
>
> It might be difficult to implement, but it might really speed it up. The
key
> thing here is to search the array with a binary search or something else
> that takes advantage of its sortedness.

this page http://www.ulib.org/webRoot/Books/Numerical_Recipes/bookcpdf.html
has some very, very useful algorithms.
It's basically an on-line version on a book I have used many times. There's
a few sorting algorithms in section 8, but there's much more here as well.
Quite possibly, there are many people who've used this book, but the online
resource is nice.
I've posted the C version but it's also available in Fortran (the on I use).

jim


Post a reply to this message

From: Jan Walzer
Subject: Re: Something more theoretical....
Date: 21 Apr 2002 17:17:03
Message: <3cc32c4f@news.povray.org>
"Slime" <noo### [at] hotmailcom> wrote:
> I have come up with an algorithm that, although it is still O(n^2), can
> place 16,000 spheres in, if I remember correctly, 13 minutes in the POV SDL.
> It gets faster, of course, when the spheres are less densely placed. In this
> example, about one out of every ten spheres needed more than one placement
> to find a place that didn't intersect with other spheres.

Sounds interesting ...

could you tell me the idea of the algo?

what are the test you do, and what are the constraints of the spheres placed ?


Post a reply to this message

From: Slime
Subject: Re: Something more theoretical....
Date: 21 Apr 2002 17:37:20
Message: <3cc33110$1@news.povray.org>
> could you tell me the idea of the algo?


Sure. =)

Basically, I follow these steps, where n is the number of spheres needing
placement:
1. place n spheres randomly, ignoring collisions. Store their radii
separately.
2. sort the placement array by the X coordinate. I used mergesort.
3. for each element A in the array:
 - for each element B in the array that's after A:
 -- if A and B are too close to each other, abort the inner loop. A must be
replaced.
 -- if B's X coordinate is so far away from A that they can't possibly be
too close, abort the inner loop and continue to the next A.
 - (end inner loop)
 - if A needs to be replaced, keep trying random positions, until you find
one that doesn't conflict with any position already in the array. You can
make use of the sortedness of the array when testing these points for
collisions.

As more points are replaced, the algorithm slows down, since their new
positions have to be stored in a separate array, which isn't sorted. (They
can't remain in the original array, because keeping them in that would make
that array not sorted anymore.)

That's the gist of it.

- Slime
[ http://www.slimeland.com/ ]
[ http://www.slimeland.com/images/ ]


Post a reply to this message

<<< Previous 10 Messages Goto Initial 10 Messages

Copyright 2003-2023 Persistence of Vision Raytracer Pty. Ltd.